#ifdef GL_ES
//precision mediump float;
//precision mediump int;
precision highp float;
precision highp int;
#endif

////////////////////////////////////////////////////////////////////////////////
uniform int SpaceMask;//water, earth air, magma, and etc. 0 is the normal air

////////////////////////////////////////////////////////////////////////////////
varying vec4 clipspacePos;
varying vec2 textureCoord;
//varying vec3 vnormal;
varying vec3 toCamera;
varying vec3 fromLight;

uniform sampler2D reflectionSampler;
uniform sampler2D refractionSampler;
uniform sampler2D dudvSampler;
uniform sampler2D normalSampler;
uniform sampler2D depthSampler;

uniform float moveFactor;
uniform float distorsionStrength;
uniform float specularPower;
uniform vec3 lightColor;
uniform float near;
uniform float far;

const vec4 mudColor = vec4(0.29, 0.27, 0.19, 0.5);

void main() {
	vec2 normalizedDeviceCoord = (clipspacePos.xy / clipspacePos.w) / 2.0 + 0.5;
//#ifndef GL_ES//LESSON: GL_CLAMP_TO_EDGE used when webgl to suport non-power-of-two. so uv can't not be nagtive?? webgl can't support the macro define??
//	vec2 reflectionTextureCoord = vec2(normalizedDeviceCoord.x, -normalizedDeviceCoord.y);
//#endif//GL_ES
	vec2 refractionTextureCoord = vec2(normalizedDeviceCoord.x, normalizedDeviceCoord.y);
#if 1
	float terrainDepth = texture2D(depthSampler, refractionTextureCoord).r;
	float terrainDistance = 2.0 * near * far / (far + near - (2.0 * terrainDepth - 1.0) * (far - near));

	float fragmentDepth = gl_FragCoord.z;
	float fragmentDistance = 2.0 * near * far / (far + near - (2.0 * fragmentDepth - 1.0) * (far - near));

	float waterDepth = terrainDistance - fragmentDistance;

	vec2 distortedTexCoords = texture2D(dudvSampler, vec2(textureCoord.x + moveFactor, textureCoord.y)).rg * 0.1;
	distortedTexCoords = textureCoord + vec2(distortedTexCoords.x, distortedTexCoords.y + moveFactor);
	vec2 totalDistortion = (texture2D(dudvSampler, distortedTexCoords).rg * 2.0 - 1.0) * distorsionStrength * clamp(waterDepth / 20.0, 0.0, 1.0);

	refractionTextureCoord += totalDistortion;
	refractionTextureCoord = clamp(refractionTextureCoord, 0.001, 0.999);

//#ifndef GL_ES//LESSON: GL_CLAMP_TO_EDGE used when webgl to suport non-power-of-two. so uv can't not be nagtive?? set the value after all calculation about reflectionTextureCoord such as distortion and etc.
//	reflectionTextureCoord += totalDistortion;
//	reflectionTextureCoord.x = clamp(reflectionTextureCoord.x, 0.001, 0.999);
//	reflectionTextureCoord.y = clamp(reflectionTextureCoord.y, -0.999, -0.001);
//#else//GL_ES
	vec2 reflectionTextureCoord= refractionTextureCoord;
	reflectionTextureCoord.t= 1.0 - refractionTextureCoord.t;
//#endif//GL_ES
	vec4 reflectColor = texture2D(reflectionSampler, reflectionTextureCoord);
	vec4 refractColor = texture2D(refractionSampler, refractionTextureCoord);
	//refractColor = mix(refractColor, mudColor, clamp(waterDepth / 60.0, 0.0, 1.0));

	vec4 normalMapColor = texture2D(normalSampler, distortedTexCoords);
	vec3 normal = vec3(normalMapColor.r * 2.0 - 1.0, normalMapColor.b * 3.0, normalMapColor.g * 2.0 - 1.0);
	normal = normalize(normal);

	vec3 viewVector = normalize(toCamera);
	float refractiveFactor = dot(viewVector, normal);
	refractiveFactor = pow(refractiveFactor, 0.5);
	if (SpaceMask == 1) {
		refractiveFactor*= 1.5;	
	}
	else {
		refractiveFactor*= 0.4;	
	}

	refractiveFactor = clamp(refractiveFactor, 0.001, 0.999);

	vec3 reflectedLight = reflect(normalize(fromLight), normal);
	float specular = max(dot(reflectedLight, viewVector), 0.0);
	specular = pow(specular, specularPower);
	vec3 specularHighlights = lightColor * specular * 0.5;

	gl_FragColor = mix(reflectColor, refractColor, refractiveFactor);
	gl_FragColor = mix(gl_FragColor, vec4(0.0, 0.3, 0.5, 1.0), 0.2) + vec4(specularHighlights, 0);
	gl_FragColor.a = clamp(waterDepth / 5.0, 0.0, 1.0);

#else//1
	//vec4 reflectColor = texture2D(reflectionSampler, outTextureCoord);
	//vec4 refractColor = texture2D(refractionSampler, outTextureCoord);
	//gl_FragColor = mix(reflectColor, refractColor, 0.8);

	//gl_FragColor = vec4(1.0, 0.5, 0.2, 1.0);
	//gl_FragColor = texture2D(reflectionSampler, reflectionTextureCoord);// +5 * vec4(1.0, 0.0, 0.0, 1.0);
	//gl_FragColor = texture2D(reflectionSampler, refractionTextureCoord);// +5 * vec4(1.0, 0.0, 0.0, 1.0);
	//gl_FragColor = texture2D(reflectionSampler, outTextureCoord);
	//gl_FragColor = texture2D(refractionSampler, outTextureCoord);
	//gl_FragColor = texture2D(refractionSampler, refractionTextureCoord) + vec4(1.0, 0.0, 0.0, 1.0);
	//gl_FragColor = texture2D(dudvSampler, outTextureCoord);// +5 * vec4(1.0, 0.0, 0.0, 1.0);
	//gl_FragColor = reflectColor;
	//gl_FragColor = texture2D(depthSampler, refractionTextureCoord);

	vec2 t= refractionTextureCoord;
	t[1]= 1.0-t[1];
	gl_FragColor = texture2D(reflectionSampler, t);// +5 * vec4(1.0, 0.0, 0.0, 1.0);
	//gl_FragColor = texture2D(reflectionSampler, refractionTextureCoord);// +5 * vec4(1.0, 0.0, 0.0, 1.0);
	vec4 reflectColor = texture2D(reflectionSampler, t);
	vec4 refractColor = texture2D(refractionSampler, refractionTextureCoord);
	gl_FragColor = mix(reflectColor, refractColor, 0.2);

#endif//1
}
