#ifdef GL_ES
//precision mediump float;
//precision mediump int;
precision highp float;
precision highp int;
#endif

////////////////////////////////////////////////////////////////////////////////
varying vec2 outTextureCoord;

////////////////////////////////////////////////////////////////////////////////
uniform mat4 gWorld;
uniform mat4 gProj;
uniform mat4 gCamera;

attribute vec4 inPosition;
attribute vec2 inTextureCoord;
//attribute vec3 inNormal;

varying vec4 clipspacePos;
varying vec2 textureCoord;
//varying vec3 vnormal;
varying vec3 toCamera;
varying vec3 fromLight;

uniform float textureTiling;
uniform vec3 cameraPosition;
uniform vec3 lightPosition;

void main() {
	outTextureCoord = inTextureCoord;


	vec4 world_pos = gWorld * inPosition;
	clipspacePos = gProj * gCamera * world_pos;
#if 0
	// (-0.5 < pos < 0.5) -> (0.0 < pos < 1.0)
	textureCoord = normalize(vec2(inPosition[0], inPosition[2])) + 0.5;
	textureCoord = textureCoord * textureTiling;
#else//1
	textureCoord = inTextureCoord * textureTiling;
#endif//1
	//vnormal = inNormal;
	toCamera = cameraPosition - world_pos.xyz;
	fromLight = world_pos.xyz - lightPosition;

	gl_Position = clipspacePos;
}
