import woxiao
import util

timers_ = []
cmdQue_ = []
cmdPool_ = []

class Timer:
    def __init__(self):
        global timers_
        timers_.append(self)
        self.value = 0
        pass
    def __del__(self):
        global timers_
        timers_.remove(self)
        pass
    def clear(self):
        self.value = 0
        pass

class CmdTask:
    def __init__(self, cmd, delay):
        if not util.isFunction(cmd):
            raise TypeError('CmdTask() argument 1 must be function')
        if not util.isNumber(delay):
            raise TypeError('CmdTask() argument 2 must be number')
        self.cmd = cmd
        self.delay = delay
        self.timer = delay
        pass

def pushDelayCommand(cmd, delay):
    global cmdQue_
    cmdQue_.append(CmdTask(cmd, delay))
    pass

def setDelayCommand(cmd, delay):
    global cmdPool_
    cmdPool_.append(CmdTask(cmd, delay))
    pass

def updateCmdQue_(stamp, deltaTime):
    global cmdQue_
    if len(cmdQue_) == 0:
        return
    cmdQue_[0].timer = cmdQue_[0].timer - deltaTime
    if cmdQue_[0].timer <= 0:
        cmdQue_[0].cmd()
        cmdQue_.pop(0)
    pass

def updateCmdPool_(stamp, deltaTime):
    global cmdPool_
    for task in cmdPool_[::-1]:
        task.timer = task.timer - deltaTime
        if task.timer <= 0:
            task.cmd()
            cmdPool_.remove(task)
    pass

def onInterpolate_(stamp, deltaTime):
    global timers_
    for timer in timers_:
        timer.value = timer.value + deltaTime
    updateCmdQue_(stamp, deltaTime)
    updateCmdPool_(stamp, deltaTime)
    pass

if __name__ != "__main__":
    woxiao.pyAppSetCBInterpolate(onInterpolate_)
